﻿Uses ConvNetABC;
Uses System;

type
  ///<summary>Элемент датасета задачи xor.</summary>
  Data = Record
    ///<summary>Входные значения (должно быть 2).</summary>
    public x: array of Single;
    ///<summary>Выходное значение.</summary>
    public y: Single;
    ///<summary>Инициализирует элемент датасета.</summary>
    ///<param name="y">Воходное значение.</param>
    ///<param name="x">Входные значения (должно быть 2).</param>
    public constructor Create(y: Single; params x: array of Single);
    begin
      self.x := x;
      self.y := y;
    end;
  End;
Type Methods={static} class
///<summary>Создаёт датасет.</summary>
Public class function CreateDataSet(): array of Data;
begin
  Result := new Data[4];
  Result[0] := new Data(0, 0, 0);
  Result[1] := new Data(1, 0, 1);
  Result[2] := new Data(0, 1, 1);
  Result[3] := new Data(1, 1, 0);
end;
public class function GetNet(): Network;
Begin
  Result := new Network();
  var il := new InputLayer();
  il.OutputDepth := 2;
  il.OutputHeight := 1;
  il.OutputWidth := 1;
  Result.Layers.Add(il);
  var FC1 := new FullyConnLayer(10, il.OutputDepth, 1, 1);
  Result.Layers.Add(FC1);
  var ReLU1 := new SigmoidLayer(10, 1, 1);
  Result.Layers.Add(ReLU1);
  var FC2 := new FullyConnLayer(2, 10, 1, 1);
  Result.Layers.Add(FC2);
  var ReLU2 := new SigmoidLayer(2, 1, 1);
  Result.Layers.Add(ReLU2);
  Result.LossLayer := new SoftmaxLayer(2, 1, 1);
End;
End;

begin
  var net:=Methods.GetNet();
  var DS := Methods.CreateDataSet();
  var Train := new Trainer();
  Train.batch_size := 1;
  Train.Net := net;
  Train.method:=TrainingMethod.adam;
  //-> Эпохи
  for Var i := 0 to 9 do
  begin
    Console.WriteLine();
    Console.WriteLine(i.ToString() + ':');
    //-> Проходим по датасету
    for Var j := 0 to 3 do
    begin
      var v := new Vol(1, 1, 2);
      v.W := DS[j].x;
      var Res := Train.Train(v, Convert.ToInt32(DS[j].y));
      Console.WriteLine('  ' + Res.cost_loss.ToString());
    end;
  end;
  Console.WriteLine();
  Console.WriteLine('Test:');
  for Var j := 0 to 3 do
  begin
    var v := new Vol(1, 1, 2);
    v.W := DS[j].x;
    Net.&Forward(v, true);
    Console.WriteLine(Net.GetPrediction().ToString());
  end;
end.